/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Win32Thread Class & Sample Application.
 *
 * The Initial Developer of the Original Code is
 * Ehsan Akhgari <me@ehsanakhgari.org>.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// TestClassThread.cpp: implementation of the CThreadClass class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ThreadTest.h"
#include "TestClassThread.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CThreadClass::CThreadClass()
{
}

UINT const CThreadClass::s_uwmClassUpdate =
	::RegisterWindowMessage( _T("CThreadClass::s_uwmClassUpdate") );

bool CThreadClass::OnInitialize()
{
	// initialization code
	::MessageBox( NULL, m_strThreadName, _T("From Class Thread"), MB_OK );

	return true; // allow running the thread
}

UINT CThreadClass::Main()
{
	UINT ui = 11;
	while (ui)
	{
		// simulate heavy processing
		::Sleep( 1000 );

		::PostMessage( m_hwnd, CThreadClass::s_uwmClassUpdate, 0, -- ui );
	}

	return ui;
}

void CThreadClass::OnTerminate()
{
	// termination code
	::PostMessage( m_hwnd, CThreadClass::s_uwmClassUpdate, 0, 0 );
}
